#include <winsock2.h>
#include <iostream>
#include <string>
#include <conio.h>

#include "GestionnaireSockets.h"
#include "SimpleStoppeur.h"
#include "SocketServeurSimple.h"

unsigned long __stdcall Accepter    (void*);
unsigned long __stdcall Repartiteur (void*);
unsigned long __stdcall LireClavier (void*);

const short PORT_A_RESERVER= 4433;


int main ()
{
   SocketServeurSimple ssmp (PORT_A_RESERVER);

   std::cout << "Serveur lie, et pret a accepter des connexions ('q' pour quitter)" << std::endl;
   HANDLE hAccepter    = 0, hLireClavier = 0;
   DWORD idAccepter    = 0, idLireClavier = 0;

   hAccepter = CreateThread (0, 0, Accepter, &ssmp, 0, &idAccepter);
   hLireClavier = CreateThread (0, 0, LireClavier, &ssmp, 0, &idLireClavier);

   HANDLE T[]= { hAccepter, hLireClavier };
   WaitForMultipleObjects (2, T, TRUE, INFINITE);

   CloseHandle (hAccepter);
   CloseHandle (hLireClavier);
}


unsigned long __stdcall Accepter (void *p)
{
   SocketServeurSimple *ssmp = reinterpret_cast<SocketServeurSimple *>(p);
   HANDLE hRepartiteur  = 0;
   hRepartiteur = CreateThread (0, 0, Repartiteur, ssmp, 0, 0);
   do
      ssmp->accepter();
   while (!ssmp->arret_demande());
   WaitForSingleObject(hRepartiteur, INFINITE);
   CloseHandle(hRepartiteur);
   ssmp->arret_complete();
   return 0L;
}


unsigned long __stdcall Repartiteur(void *p)
{
   SocketServeurSimple *ssmp = reinterpret_cast<SocketServeurSimple *> (p);
   while (!ssmp->arret_demande())
   {
      ssmp->diffuser_nettoyer();
      Sleep(100);
   }
   ssmp->arret_complete();
   return 0L;
}

unsigned long __stdcall LireClavier(void *p)
{
   using std::string;
   SocketServeurSimple *ssmp= reinterpret_cast<SocketServeurSimple *> (p);
   const string TEXTE_FIN = "q";

   for (string s; std::getline(std::cin, s) && s != TEXTE_FIN && !ssmp->arret_demande(); )
      ;
   ssmp->demander_arret();
   ssmp->fermer_conversations();
   // Pour s'auto-gnrer un accept ()
   socket_t socketBidon = creer_socket();
   connecter(socketBidon, "127.0.0.1", PORT_A_RESERVER);
   fermer_socket(socketBidon);
   ssmp->fermer();
   ssmp->arret_complete();
   return 0L;
}



