#ifndef SOCKET_CONVERSATION_H
#define SOCKET_CONVERSATION_H

#include "StrateIsolante.h"
#include "zone_transit.h"
#include "SimpleStoppeur.h"
#include <string>

class SocketServeurSimple;

class SocketConversation
   : public SimpleStoppeur
{
   zone_transit a_envoyer_;
   socket_t socket_;
   volatile SocketServeurSimple *parent_;
   HANDLE hEnvoyer_, hRecevoir_;
   std::string en_cours_;
public:
   SocketConversation(const socket_t, volatile SocketServeurSimple*);
   void demarrer();
   ~SocketConversation() throw();
   void ajouter_texte(const std::string &texte) volatile
      { a_envoyer_.ajouter(texte); }
   void envoyer() volatile;
   void fermer();
   std::string recevoir() volatile;
};

#endif // !defined SOCKET_CONVERSATION_H
