#ifndef SOCKETSERVEURSIMPLE_H
#define SOCKETSERVEURSIMPLE_H

#include "StrateIsolante.h"
#include "zone_transit.h"
#include "SimpleStoppeur.h"
#include "Mutex.h"
#include <vector>

class SocketConversation;

class SocketServeurSimple
   : public SimpleStoppeur
{
   socket_t socket_;
   Mutex mutex_;
   std::vector<SocketConversation *> conversations_;
   zone_transit a_diffuser_;
public:
   SocketServeurSimple(const short port_denormalise);
   void fermer_conversations() volatile;
   void vider_conversations () volatile throw();
   void fermer() throw();
   ~SocketServeurSimple() throw();
   void accepter() volatile;
   void diffuser_nettoyer() volatile;
   void ajouter_diffusion(const std::string &s) volatile
      { a_diffuser_.ajouter(s); }
};

#endif
