#ifndef FILETEXTE_H
#define FILETEXTE_H

#include "Mutex.h"
#include <string>

class zone_transit
{
public:
   typedef std::string value_type;
private:
   value_type texte_;
   Mutex mutex_;
public:
   value_type extraire() volatile
   {
      Autoverrou a(mutex_);
      return const_cast<zone_transit*>(this)->extraire();
   }
   void ajouter(const value_type &val) volatile
   {
      Autoverrou a(mutex_);
      const_cast<zone_transit*>(this)->ajouter(val);
   }
   value_type extraire()
   {
      value_type temp = texte_;
      texte_.clear();
      return temp;
   }
   void ajouter(const value_type &val)
      { texte_ += val; }
};

#endif
